## xonotic-0.7.0.zip

=== Makefile ===
DESTDIR ?= 
PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
LIBDIR ?= $(PREFIX)/lib/xonotic
DOCDIR ?= $(PREFIX)/share/doc/xonotic
ZIP ?= zip -9
INSTALL ?= install
ARCH ?= $(shell if [ x"`uname -m`" = x"x86_64" ]; then echo linux64; else echo linux32; fi)
LN ?= ln
CP ?= cp
BINARY ?= yes
SUFFIX ?= $(shell if [ -d .git ]; then echo git; elif [ x"$(BINARY)" = x"yes" ]; then echo zip-binary; else echo zip-source; fi)
RIJNDAELDETECT_CONFIGURE ?= $(shell if ! [ -f source/d0_blind_id/d0_rijndael.c ]; then echo --disable-rijndael; fi)
RIJNDAELDETECT_MAKE_DP ?= $(shell if [ -f source/d0_blind_id/d0_rijndael.c ]; then echo DP_CRYPTO_RIJNDAEL_STATIC_LIBDIR=$(CURDIR)/source/d0_blind_id/.libs; fi)


.PHONY: all
all: all-$(SUFFIX)

.PHONY: all-git
all-git:
	./all compile -r

.PHONY: all-zip-binary
all-zip-binary:
	@echo Nothing to do

.PHONY: all-zip-source
all-zip-source:
	( cd source/d0_blind_id && ./configure --enable-static --disable-shared $(RIJNDAELDETECT_CONFIGURE) )
	$(MAKE) -C source/d0_blind_id
	$(MAKE) -C source/gmqcc
	$(MAKE) -C source/qcsrc FTEQCC=$(CURDIR)/source/gmqcc/gmqcc
	$(MAKE) -C source/darkplaces sv-release DP_CRYPTO_STATIC_LIBDIR=$(CURDIR)/source/d0_blind_id/.libs
	$(MAKE) -C source/darkplaces cl-release DP_CRYPTO_STATIC_LIBDIR=$(CURDIR)/source/d0_blind_id/.libs
	$(MAKE) -C source/darkplaces sdl-release DP_CRYPTO_STATIC_LIBDIR=$(CURDIR)/source/d0_blind_id/.libs


.PHONY: clean
clean: clean-$(SUFFIX)

.PHONY: clean-git
clean-git:
	./all clean

.PHONY: clean-zip
clean-zip-binary:
	@echo Nothing to do

.PHONY: clean-zip
clean-zip-source:
	-$(MAKE) -C source/d0_blind_id distclean
	$(MAKE) -C source/gmqcc clean
	$(MAKE) -C source/qcsrc clean
	$(MAKE) -C source/darkplaces clean


.PHONY: install-data
install-data: install-data-$(SUFFIX)

.PHONY: install-data-git
install-data-git: all-git
	$(RM) -rf $(DESTDIR)$(LIBDIR)/data
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/data
	for p in data/*.pk3; do $(INSTALL) $$p $(DESTDIR)$(LIBDIR)/$$p || exit 1; done
	for p in data/*.pk3dir; do ( cd $$p && $(ZIP) -r $(DESTDIR)$(LIBDIR)/$${p%dir} * ) || exit 1; done

.PHONY: install-data-zip-binary
install-data-zip-binary: all-zip-binary
	$(RM) -rf $(DESTDIR)$(LIBDIR)/data
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/data
	for p in data/*.pk3; do $(INSTALL) $$p $(DESTDIR)$(LIBDIR)/$$p || exit 1; done

.PHONY: install-data-zip-source
install-data-zip-source: all-zip-source
	$(RM) -rf $(DESTDIR)$(LIBDIR)/data
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/data
	for p in data/*.pk3; do $(INSTALL) $$p $(DESTDIR)$(LIBDIR)/$$p || exit 1; done
	for p in data/xonotic-*-data*.pk3; do cd source && $(ZIP) $(DESTDIR)$(LIBDIR)/$$p progs.dat menu.dat csprogs.dat; done


.PHONY: install-engine
install-engine: install-engine-$(SUFFIX)

.PHONY: install-engine-git
install-engine-git: all-git
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL) xonotic-linux-glx.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-glx.sh
	$(INSTALL) xonotic-linux-sdl.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-sdl.sh
	$(INSTALL) xonotic-linux-dedicated.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-dedicated.sh
	$(INSTALL) darkplaces/darkplaces-sdl $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-sdl
	$(INSTALL) darkplaces/darkplaces-glx $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-glx
	$(INSTALL) darkplaces/darkplaces-dedicated $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-dedicated

.PHONY: install-engine-zip-binary
install-engine-zip-binary: all-zip-binary
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL) xonotic-linux-glx.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-glx.sh
	$(INSTALL) xonotic-linux-sdl.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-sdl.sh
	$(INSTALL) xonotic-linux-dedicated.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-dedicated.sh
	$(INSTALL) xonotic-$(ARCH)-sdl $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-sdl
	$(INSTALL) xonotic-$(ARCH)-glx $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-glx
	$(INSTALL) xonotic-$(ARCH)-dedicated $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-dedicated

.PHONY: install-engine-zip-source
install-engine-zip-source: all-zip-source
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL) xonotic-linux-glx.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-glx.sh
	$(INSTALL) xonotic-linux-sdl.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-sdl.sh
	$(INSTALL) xonotic-linux-dedicated.sh $(DESTDIR)$(LIBDIR)/xonotic-linux-dedicated.sh
	$(INSTALL) source/darkplaces/darkplaces-sdl $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-sdl
	$(INSTALL) source/darkplaces/darkplaces-glx $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-glx
	$(INSTALL) source/darkplaces/darkplaces-dedicated $(DESTDIR)$(LIBDIR)/xonotic-$(ARCH)-dedicated


.PHONY: install-links
install-links:
	$(INSTALL) -d $(BINDIR)
	$(LN) -snf $(LIBDIR)/xonotic-linux-sdl.sh $(DESTDIR)$(BINDIR)/xonotic-sdl
	$(LN) -snf $(LIBDIR)/xonotic-linux-glx.sh $(DESTDIR)$(BINDIR)/xonotic-glx
	$(LN) -snf $(LIBDIR)/xonotic-linux-dedicated.sh $(DESTDIR)$(BINDIR)/xonotic-dedicated


.PHONY: install-doc
install-doc:
	$(INSTALL) -d $(DESTDIR)$(DOCDIR)/server
	$(CP) -R Docs/* $(DESTDIR)$(DOCDIR)/
	$(CP) -R server/* $(DESTDIR)$(DOCDIR)/server


.PHONY: install
install: install-data install-engine install-links install-doc

=== source/gmqcc/Makefile ===
DESTDIR :=
OPTIONAL:=
PREFIX  := /usr/local
BINDIR  := $(PREFIX)/bin
DATADIR := $(PREFIX)/share
MANDIR  := $(DATADIR)/man

UNAME  ?= $(shell uname)
CYGWIN  = $(findstring CYGWIN,  $(UNAME))
MINGW   = $(findstring MINGW32, $(UNAME))

CC      ?= clang
# linker flags and optional additional libraries if required
LDFLAGS +=
LIBS    += -lm

CFLAGS  += -Wall -Wextra -Werror -fno-strict-aliasing $(OPTIONAL)
ifneq ($(shell git describe --always 2>/dev/null),)
    CFLAGS += -DGMQCC_GITINFO="\"$(shell git describe --always)\""
endif
#turn on tons of warnings if clang is present
# but also turn off the STUPID ONES
ifeq ($(CC), clang)
	CFLAGS +=                              \
	    -Weverything                       \
	    -Wno-padded                        \
	    -Wno-format-nonliteral             \
	    -Wno-disabled-macro-expansion      \
	    -Wno-conversion                    \
	    -Wno-missing-prototypes            \
	    -Wno-float-equal                   \
	    -Wno-unknown-warning-option
else
	#Tiny C Compiler doesn't know what -pedantic-errors is
	# and instead of ignoring .. just errors.
	ifneq ($(CC), tcc)
		CFLAGS += -pedantic-errors
	else
		CFLAGS += -Wno-pointer-sign -fno-common
	endif
endif

ifeq ($(track), no)
	CFLAGS += -DNOTRACK
endif

OBJ_D = util.o code.o ast.o ir.o conout.o ftepp.o opts.o fs.o utf8.o correct.o
OBJ_P = util.o fs.o conout.o opts.o pak.o
OBJ_T = test.o util.o conout.o fs.o
OBJ_C = main.o lexer.o parser.o fs.o
OBJ_X = exec-standalone.o util.o conout.o fs.o

ifneq ("$(CYGWIN)", "")
	#nullify the common variables that
	#most *nix systems have (for windows)
	PREFIX   :=
	BINDIR   :=
	DATADIR  :=
	MANDIR   :=
	QCVM      = qcvm.exe
	GMQCC     = gmqcc.exe
	TESTSUITE = testsuite.exe
	PAK       = pak.exe
else
ifneq ("$(MINGW)", "")
	#nullify the common variables that
	#most *nix systems have (for windows)
	PREFIX   :=
	BINDIR   :=
	DATADIR  :=
	MANDIR   :=
	QCVM      = qcvm.exe
	GMQCC     = gmqcc.exe
	TESTSUITE = testsuite.exe
	PAK       = pak.exe
else
	QCVM      = qcvm
	GMQCC     = gmqcc
	TESTSUITE = testsuite
	PAK       = pak
endif
endif

#gource flags
GOURCEFLAGS=                  \
    --date-format "%d %B, %Y" \
    --seconds-per-day 0.01    \
    --auto-skip-seconds 1     \
    --title "GMQCC"           \
    --key                     \
    --camera-mode overview    \
    --highlight-all-users     \
    --file-idle-time 0        \
    --hide progress,mouse     \
    --stop-at-end             \
    --max-files 99999999999   \
    --max-file-lag 0.000001   \
    --bloom-multiplier 1.3    \
    --logo doc/html/gmqcc.png \
    -1280x720

#ffmpeg flags for gource
FFMPEGFLAGS=                  \
    -y                        \
    -r 60                     \
    -f image2pipe             \
    -vcodec ppm               \
    -i -                      \
    -vcodec libx264           \
    -preset ultrafast         \
    -crf 1                    \
    -threads 0                \
    -bf 0

#splint flags
SPLINTFLAGS =            \
    -redef               \
    -noeffect            \
    -nullderef           \
    -usedef              \
    -type                \
    -mustfreeonly        \
    -nullstate           \
    -varuse              \
    -mustfreefresh       \
    -compdestroy         \
    -compmempass         \
    -nullpass            \
    -onlytrans           \
    -predboolint         \
    -boolops             \
    -exportlocal         \
    -incondefs           \
    -macroredef          \
    -retvalint           \
    -nullret             \
    -predboolothers      \
    -globstate           \
    -dependenttrans      \
    -branchstate         \
    -compdef             \
    -temptrans           \
    -usereleased         \
    -warnposix           \
    -shiftimplementation \
    +charindex           \
    -kepttrans           \
    -unqualifiedtrans    \
    +matchanyintegral    \
    +voidabstract        \
    -nullassign          \
    -unrecog             \
    -casebreak           \
    -retvalbool          \
    -retvalother         \
    -mayaliasunique      \
    -realcompare         \
    -observertrans       \
    -shiftnegative       \
    -freshtrans          \
    -abstract            \
    -statictrans         \
    -castfcnptr

#standard rules
default: all
%.o: %.c
	$(CC) -c $< -o $@ $(CPPFLAGS) $(CFLAGS)

exec-standalone.o: exec.c
	$(CC) -c $< -o $@ $(CPPFLAGS) $(CFLAGS) -DQCVM_EXECUTOR=1

$(QCVM): $(OBJ_X)
	$(CC) -o $@ $^ $(LDFLAGS) $(LIBS)

$(GMQCC): $(OBJ_C) $(OBJ_D)
	$(CC) -o $@ $^ $(LDFLAGS) $(LIBS)

$(TESTSUITE): $(OBJ_T)
	$(CC) -o $@ $^ $(LDFLAGS) $(LIBS)

$(PAK): $(OBJ_P)
	$(CC) -o $@ $^ $(LDFLAGS)

all: $(GMQCC) $(QCVM) $(TESTSUITE) $(PAK)

check: all
	@ ./$(TESTSUITE)
test: all
	@ ./$(TESTSUITE)

clean:
	rm -f *.o $(GMQCC) $(QCVM) $(TESTSUITE) $(PAK) *.dat gource.mp4 *.exe

splint:
	@  splint $(SPLINTFLAGS) *.c *.h

gource:
	@ gource $(GOURCEFLAGS)

gource-record:
	@ gource $(GOURCEFLAGS) -o - | ffmpeg $(FFMPEGFLAGS) gource.mp4

depend:
	@makedepend    -Y -w 65536 2> /dev/null \
		$(subst .o,.c,$(OBJ_D))
	@makedepend -a -Y -w 65536 2> /dev/null \
		$(subst .o,.c,$(OBJ_T))
	@makedepend -a -Y -w 65536 2> /dev/null \
		$(subst .o,.c,$(OBJ_C))
	@makedepend -a -Y -w 65536 2> /dev/null \
		$(subst .o,.c,$(OBJ_X))
	@makedepend -a -Y -w 65536 2> /dev/null \
		$(subst .o,.c,$(OBJ_P))

#install rules
install: install-gmqcc install-qcvm install-doc
install-gmqcc: $(GMQCC)
	install -d -m755               $(DESTDIR)$(BINDIR)
	install    -m755  $(GMQCC)     $(DESTDIR)$(BINDIR)/$(GMQCC)
install-qcvm: $(QCVM)
	install -d -m755               $(DESTDIR)$(BINDIR)
	install    -m755  $(QCVM)      $(DESTDIR)$(BINDIR)/$(QCVM)
install-doc:
	install -d -m755               $(DESTDIR)$(MANDIR)/man1
	install    -m644  doc/gmqcc.1  $(DESTDIR)$(MANDIR)/man1/
	install    -m644  doc/qcvm.1   $(DESTDIR)$(MANDIR)/man1/

uninstall:
	rm $(DESTDIR)$(BINDIR)/gmqcc
	rm $(DESTDIR)$(BINDIR)/qcvm
	rm $(DESTDIR)$(MANDIR)/man1/doc/gmqcc.1
	rm $(DESTDIR)$(MANDIR)/man1/doc/qcvm.1

# DO NOT DELETE

util.o: gmqcc.h opts.def
code.o: gmqcc.h opts.def
ast.o: gmqcc.h opts.def ast.h ir.h
ir.o: gmqcc.h opts.def ir.h
conout.o: gmqcc.h opts.def
ftepp.o: gmqcc.h opts.def lexer.h
opts.o: gmqcc.h opts.def
fs.o: gmqcc.h opts.def
utf8.o: gmqcc.h opts.def
correct.o: gmqcc.h opts.def

test.o: gmqcc.h opts.def
util.o: gmqcc.h opts.def
conout.o: gmqcc.h opts.def
fs.o: gmqcc.h opts.def

main.o: gmqcc.h opts.def lexer.h
lexer.o: gmqcc.h opts.def lexer.h
parser.o: gmqcc.h opts.def lexer.h ast.h ir.h intrin.h
fs.o: gmqcc.h opts.def

util.o: gmqcc.h opts.def
conout.o: gmqcc.h opts.def
fs.o: gmqcc.h opts.def

util.o: gmqcc.h opts.def
fs.o: gmqcc.h opts.def
conout.o: gmqcc.h opts.def
opts.o: gmqcc.h opts.def
pak.o: gmqcc.h opts.def

=== source/qcsrc/Makefile ===
SCM := $(shell if [ -d .svn ]; then echo svn; elif [ -d ../.git ]; then echo git; fi)
PERL ?= perl
QCCFLAGS_WATERMARK ?= -DWATERMARK='"$(shell git describe)"' -DCVAR_POPCON=1
QCC ?= gmqcc

VERSION_MESSAGE = $(shell cd server && $(QCC) --version --help)
ifneq (,$(findstring GMQCC,$(VERSION_MESSAGE)))
# this is gmqcc
QCCFLAGS ?= \
	-std=fteqcc \
	-Werror -Wall \
	-Wno-field-redeclared \
	-Wno-double-declaration \
	-Wno-uninitialized-global \
	-O3 \
	-fadjust-vector-fields \
	-fftepp \
	-fftepp-predefs \
	-frelaxed-switch \
	-fshort-logic \
	-fno-perl-logic \
	-ftranslatable-strings \
	-fno-initialized-nonconstants \
	-fno-assign-function-types \
	-flno \
	-fcorrect-ternary \
	-fno-single-vector-defs \
	-fcorrect-logic \
	-ftrue-empty-strings \
	-fno-false-empty-strings \
	-futf8 \
	-fno-bail-on-werror \
	-floop-labels \
	-funtyped-nil \
	-fno-permissive \
	-fvariadic-args \
	$(QCCFLAGS_EXTRA) $(QCCFLAGS_WATERMARK)
else
# this. is. fteqccccccccccccccccccc!
QCCFLAGS ?= -Werror -Wno-Q302 -O3 -Ono-return_only -fno-fastarrays $(QCCFLAGS_EXTRA) $(QCCFLAGS_WATERMARK)
endif

# xonotic build system overrides this by command line argument to turn off the update-cvarcount step
XON_BUILDSYSTEM =

all: qc

.PHONY: qc
qc:
	$(MAKE) qc-recursive

.PHONY: qc-recursive
qc-recursive: ../menu.dat ../progs.dat ../csprogs.dat

.PHONY: clean
clean:
	rm -f ../progs.dat ../menu.dat ../csprogs.dat

FILES_CSPROGS = $(shell find client common warpzonelib csqcmodellib -type f -not -name fteqcc.log -not -name qc.asm) $(wildcard server/w_*.qc)
../csprogs.dat: $(FILES_CSPROGS)
	@echo make[1]: Entering directory \`$(PWD)/client\'
	cd client && $(QCC) $(QCCFLAGS)

FILES_PROGS = $(shell find server common warpzonelib csqcmodellib -type f -not -name fteqcc.log -not -name qc.asm) $(wildcard server/w_*.qc)
../progs.dat: $(FILES_PROGS)
	@echo make[1]: Entering directory \`$(PWD)/server\'
	cd server && $(QCC) $(QCCFLAGS)

FILES_MENU = $(shell find menu common warpzonelib -type f -not -name fteqcc.log -not -name qc.asm) $(wildcard server/w_*.qc)
../menu.dat: $(FILES_MENU)
	@echo make[1]: Entering directory \`$(PWD)/menu\'
	cd menu && $(QCC) $(QCCFLAGS)

.PHONY: testcase
testcase:
	cd testcase && $(QCC) $(QCCFLAGS) -DTESTCASE="$$TESTCASE"

=== source/gmqcc/distro/Makefile ===
DROPBOX := dropbox_uploader.sh
UNAME   := $(shell uname -m)
DOWNLOAD:= ../doc/html/download.c
BRANCH  := $(shell git branch | sed -n -e 's/^\* \(.*\)/\1/p')
ifneq ($(shell uname -m), x86_64)
    $(error Cannot build packages without an x86_64 capable CPU)
endif

.NOTPARALLEL: base
.NOTPARALLEL: upload

base:
	$(MAKE) -C deb/
	$(MAKE) -C deb/ CARCH=i686
	$(MAKE) -C archlinux/this/
	$(MAKE) -C archlinux/this/ CARCH=i686
	$(MAKE) -C win32/
	@mv deb/*.deb ./
	@mv archlinux/this/*pkg.tar.xz ./
	@mv win32/*.zip ./

upload:
	@echo "APPKEY:76vh3q42hnvmzm3" > dropbox_config
	@echo "APPSECRET:tmeecht2cmh72xa" >> dropbox_config
	@echo "ACCESS_LEVEL:sandbox" >> dropbox_config
	@echo "OAUTH_ACCESS_TOKEN:w0bxzf0dft8edfq" >> dropbox_config
	@echo "OAUTH_ACCESS_TOKEN_SECRET:9vosx7x8gy4kgjk" >> dropbox_config
	@wget -q "http://raw.github.com/andreafabrizi/Dropbox-Uploader/master/dropbox_uploader.sh"
	@chmod +x dropbox_uploader.sh
	@sed -i -e "s/~\/.dropbox_uploader/.\/dropbox_config/g" $$(basename $(DROPBOX))
	@find . -type f -regex ".*/.*\.\(xz\|deb\|zip\)" -exec ./$$(basename $(DROPBOX)) upload {} \;
	@rm dropbox_config dropbox_uploader.sh

website:
	$(CC) $(DOWNLOAD) -o html.gen
	@./html.gen ../
	@rm html.gen
	@git stash
	@git checkout gh-pages
	@rm -f ../download.html
	@mv -f download.html ../download.html
	@cd ..; git add download.html; git commit -m 'update download page'; git push origin gh-pages;
	@git checkout $(BRANCH)
	@git stash apply

clean:
	@rm -f *.deb
	@rm -f *.pkg.tar.xz
	@rm -f *.zip
	@rm -f *.gen
	@rm -f *.html

all: base upload

=== source/gmqcc/distro/deb/Makefile ===
BASEDIR := ../..
PREFIX  := /usr
HEADER  := $(BASEDIR)/gmqcc.h
MAJOR   := `sed -n -e '/GMQCC_VERSION_MAJOR/{s/.* .* //;p;q;}' $(HEADER)`
MINOR   := `sed -n -e '/GMQCC_VERSION_MINOR/{s/.* .* //;p;q;}' $(HEADER)`
PATCH   := `sed -n -e '/GMQCC_VERSION_PATCH/{s/.* .* //;p;q;}' $(HEADER)`
DEBDIR  := gmqcc-$(MAJOR).$(MINOR).$(PATCH)
CARCH   := $(shell uname -m)
DEB     := $(DEBDIR)-$(CARCH).deb
CONTROL := $(DEBDIR)/DEBIAN/control

ifneq (, $(findstring i686, $(CARCH)))
	CFLAGS := -m32
endif

base:
	$(MAKE) -C $(BASEDIR) clean
	$(MAKE) -C $(BASEDIR) DESTDIR=distro/deb/$(DEBDIR) PREFIX=$(PREFIX) install
	@install -d -m755 $(DEBDIR)/DEBIAN
	@echo "Package: gmqcc" > $(CONTROL)
	@echo "Version: $(MAJOR).$(MINOR).$(PATCH)" >> $(CONTROL)
	@echo "Section: user/hidden" >> $(CONTROL)
	@echo "Priority: optional" >> $(CONTROL)
	@echo "Architecture: $(CARCH)" >> $(CONTROL)
	@echo "Installed-Size: `du -ks $($(DEBDIR)/usr) | cut -f 1`" >> $(CONTROL)
	@echo "Maintainer: Dale Weiler <killfieldengine@gmail.com>" >> $(CONTROL)
	@echo "Description: An improved Quake C Compiler" >> $(CONTROL)
	@echo "   For an enduring period of time the options for a decent compiler for the Quake C programming language" >> $(CONTROL)
	@echo "   were confined to a specific compiler known as QCC. Attempts were made to extend and improve upon the" >> $(CONTROL)
	@echo "   design of QCC, but many foreseen the consequences of building on a broken foundation. The solution" >> $(CONTROL)
	@echo "   was obvious, a new compiler; one born from the NIH realm of sarcastic wit. We welcome you. You won't" >> $(CONTROL)
	@echo "   find a better Quake C compiler." >> $(CONTROL)
	@tar czf data.tar.gz -C $(DEBDIR)/ . --exclude=DEBIAN
	@tar czf control.tar.gz -C $(DEBDIR)/DEBIAN/ .
	@echo 2.0 > debian-binary
	@ar r $(DEB) debian-binary control.tar.gz data.tar.gz
	@rm -rf debian-binary control.tar.gz data.tar.gz $(DEBDIR)

clean:
	$(MAKE) -C $(BASEDIR) clean
	@rm -f *.deb

all: base

=== source/gmqcc/distro/win32/Makefile ===
BASEDIR := ../..
HEADER  := $(BASEDIR)/gmqcc.h
MAJOR   := `sed -n -e '/GMQCC_VERSION_MAJOR/{s/.* .* //;p;q;}' $(HEADER)`
MINOR   := `sed -n -e '/GMQCC_VERSION_MINOR/{s/.* .* //;p;q;}' $(HEADER)`
PATCH   := `sed -n -e '/GMQCC_VERSION_PATCH/{s/.* .* //;p;q;}' $(HEADER)`
BINDIR  := gmqcc-$(MAJOR).$(MINOR).$(PATCH)

base:
	$(MAKE) CC=i486-mingw32-gcc UNAME=MINGW32 -C $(BASEDIR) clean
	$(MAKE) CC=i486-mingw32-gcc UNAME=MINGW32 -C $(BASEDIR) DESTDIR=distro/win32/$(BINDIR) PREFIX=/ install
	@zip -r $(BINDIR)-win32.zip $(BINDIR)
	@rm -rf $(BINDIR)
clean:
	$(MAKE) -C $(BASEDIR) clean
	@rm -f *.zip

all: base

=== source/gmqcc/distro/archlinux/this/Makefile ===
BASEDIR := ../../../
PREFIX  := /usr
HEADER  := $(BASEDIR)/gmqcc.h
MAJOR   := $(shell sed -n -e '/GMQCC_VERSION_MAJOR/{s/.* .* //;p;q;}' $(HEADER))
MINOR   := $(shell sed -n -e '/GMQCC_VERSION_MINOR/{s/.* .* //;p;q;}' $(HEADER))
PATCH   := $(shell sed -n -e '/GMQCC_VERSION_PATCH/{s/.* .* //;p;q;}' $(HEADER))
PKGREL  := 1
CARCH   := $(shell uname -m)
PKGDIR  := gmqcc-$(MAJOR).$(MINOR).$(PATCH)-$(PKGREL)-$(CARCH)
PKG     := $(PKGDIR).pkg.tar.xz
PKGINFO := $(PKGDIR)/.PKGINFO
DESTDIR := distro/archlinux/this/$(PKGDIR)
CFLAGS  :=


ifneq (, $(findstring i686, $(CARCH)))
	CFLAGS += -m32
	LDFLAGS += -m32
endif

base:
	$(MAKE) -C $(BASEDIR) clean
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	  $(MAKE) -C $(BASEDIR) "DESTDIR=$(DESTDIR)" "PREFIX=$(PREFIX)" install
	@echo "pkgname = gmqcc" > $(PKGINFO)
	@echo "pkgver = $(MAJOR).$(MINOR).$(PATCH)-$(PKGREL)" >> $(PKGINFO)
	@echo "pkgdesc = An Improved Quake C Compiler" >> $(PKGINFO)
	@echo "url = https://github.com/graphitemaster/gmqcc.git" >> $(PKGINFO)
	@echo "builddate = `date -u \"+%s\"`" >> $(PKGINFO)
	@echo "packager = Unknown Packager" >> $(PKGINFO)
	@echo "size = `du -sk $(PKGDIR) | awk '{print $$1 * 1024}'`" >> $(PKGINFO)
	@echo "arch = $(CARCH)" >> $(PKGINFO)
	@echo "license = MIT" >> $(PKGINFO)
	@echo "conflict = gmqcc" >> $(PKGINFO)
	@echo "depend = glibc" >> $(PKGINFO)
	@echo "makepkgopt = strip" >> $(PKGINFO)
	@echo "makepkgopt = docs" >> $(PKGINFO)
	@echo "makepkgopt = libtool" >> $(PKGINFO)
	@echo "makepkgopt = emptydirs" >> $(PKGINFO)
	@echo "makepkgopt = zipman" >> $(PKGINFO)
	@echo "makepkgopt = purge" >> $(PKGINFO)
	@echo "makepkgopt = !upx" >> $(PKGINFO)
	@tar -cJvf $(PKG) -C $(PKGDIR)/ .PKGINFO usr/
	@rm -rf $(PKGDIR)

clean:
	$(MAKE) -C $(BASEDIR) clean
	@rm -f *.pkg.tar.xz

all: base

=== source/gmqcc/distro/archbsd/git/PKGBUILD ===
# Contributor: matthiaskrgr <matthiaskrgr _strange_curverd_character_ freedroid D0T org>
# Contributor: Wolfgang Bumiller <blub@speed.at>

pkgname=gmqcc-git
pkgver=20130127
pkgrel=1
pkgdesc="An Improved Quake C Compiler"
arch=('i686' 'x86_64')
depends=()
conflicts=('gmqcc')
provides=('gmqcc=0.2.4')
makedepends=('git')
url="https://github.com/graphitemaster/gmqcc.git"
license=('MIT')

_gitroot="git://github.com/graphitemaster/gmqcc.git"
_gitname="gmqcc"

build() {
	cd $srcdir
	msg "Connecting to the GIT server..."
	if [[ -d $srcdir/$_gitname ]] ; then
		cd $_gitname
		msg "Removing build files..."
		git clean -dfx
		msg "Updating..."
		git pull --no-tags
		msg "The local files are updated."
	else
		msg "Cloning..."
		git clone $_gitroot $_gitname --depth 1
		msg "Clone done."
	fi

	msg "Starting compilation..."
	cd "$srcdir"/"$_gitname"

	msg "Compiling..."
	gmake
}

check() {
	cd "$srcdir"/"$_gitname"
	gmake check
}

package() {
	cd "$srcdir"/"$_gitname"
	msg "Compiling and installing to pkgdir this time..."
	gmake install DESTDIR=$pkgdir PREFIX=/usr
	msg "Compiling done."

	install -dm755 ${pkgdir}/usr/share/licenses/gmqcc
	install -m644 LICENSE ${pkgdir}/usr/share/licenses/gmqcc/LICENSE
}

=== source/gmqcc/distro/archbsd/release/PKGBUILD ===
# Contributor: matthiaskrgr <matthiaskrgr _strange_curverd_character_ freedroid D0T org>
# Contributor: Wolfgang Bumiller <blub@speed.at>

pkgname=gmqcc
pkgver=0.2.9
pkgrel=1
pkgdesc="An Improved Quake C Compiler"
arch=('i686' 'x86_64')
depends=()
url="https://github.com/graphitemaster/gmqcc.git"
license=('MIT')
source=(gmqcc-$pkgver.zip::https://github.com/graphitemaster/gmqcc/zipball/$pkgver)
sha1sums=('adf972360c0b3d2f032a688952f6fb4715e4d45b')

_gitname=graphitemaster-gmqcc-219508e/

build() {
	msg "Starting compilation..."
	cd "$srcdir"/"$_gitname"

	msg "Compiling..."
	gmake
}

check() {
	cd "$srcdir"/"$_gitname"
	gmake check
}

package() {
	cd "$srcdir"/"$_gitname"
	msg "Compiling and installing to pkgdir this time..."
	gmake install DESTDIR=$pkgdir PREFIX=/usr
	msg "Compiling done."

	install -dm755 ${pkgdir}/usr/share/licenses/gmqcc
	install -m644 LICENSE ${pkgdir}/usr/share/licenses/gmqcc/LICENSE
}

=== source/gmqcc/distro/archlinux/git/PKGBUILD ===
# Contributor: matthiaskrgr <matthiaskrgr _strange_curverd_character_ freedroid D0T org>

pkgname=gmqcc-git
pkgver=0.2.612.g160e7cf
pkgver(){
    cd gmqcc
    git describe --tags | sed -e 's/^gmqcc\-//' -e 's/-/./g'
}
pkgrel=1
pkgdesc="An Improved Quake C Compiler"
arch=('i686' 'x86_64')
depends=('glibc')
conflicts=('gmqcc')
provides=('gmqcc=0.2.4')
makedepends=('git')
url="https://github.com/graphitemaster/gmqcc.git"
license=('MIT')
source=('gmqcc::git://github.com/graphitemaster/gmqcc.git')
sha1sums=('SKIP')


build() {
	msg "Starting compilation..."
	cd "$srcdir"/"gmqcc"

	msg "Compiling..."
	make
}

check() {
	cd "$srcdir"/"gmqcc"
	make check
}

package() {
	cd "$srcdir"/"gmqcc"
	msg "Compiling and installing to pkgdir this time..."
	make install DESTDIR=$pkgdir PREFIX=/usr
	msg "Compiling done."

	install -Dm644 syntax/geany/filetypes.qc    ${pkgdir}/usr/share/geany/filetypes.qc
	install -Dm644 syntax/gtksourceview/qc.lang ${pkgdir}/usr/share/gtksourceview-3.0/language-specs/qc.lang
	# jedit
	install -Dm644 syntax/kate/qc.xml ${pkgdir}/usr/share/apps/katepart/syntax/qc.xml
	install -Dm644 syntax/nano/qc.nanorc ${pkgdir}/usr/share/nano/qc.nanorc

	install -Dm644 LICENSE 					 ${pkgdir}/usr/share/licenses/gmqcc/LICENSE
}

=== source/gmqcc/distro/archlinux/release/PKGBUILD ===
# Contributor: matthiaskrgr <matthiaskrgr _strange_curverd_character_ freedroid D0T org>
# Contributor: Wolfgang Bumiller <blub@speed.at>

pkgname=gmqcc
pkgver=0.2.9
pkgrel=1
pkgdesc="An Improved Quake C Compiler"
arch=('i686' 'x86_64')
depends=('glibc')
url="https://github.com/graphitemaster/gmqcc.git"
license=('MIT')
source=(gmqcc-$pkgver.zip::https://github.com/graphitemaster/gmqcc/zipball/$pkgver
	    build_fix.patch) # commit 4c4aa5534c34

sha1sums=('adf972360c0b3d2f032a688952f6fb4715e4d45b'
		 '0b69dc8b786c7617fe17e6a5fd70407d1c4153d6')

_gitname=graphitemaster-gmqcc-219508e/

prepare() {
	cd "$srcdir"/"$_gitname"
	patch -p1 <../build_fix.patch
}

build() {
	msg "Starting compilation..."
	cd "$srcdir"/"$_gitname"

	msg "Compiling..."
	make
}

check() {
	cd "$srcdir"/"$_gitname"
	make check
}

package() {
	cd "$srcdir"/"$_gitname"
	msg "Compiling and installing to pkgdir this time..."
	make install DESTDIR=$pkgdir PREFIX=/usr
	msg "Compiling done."

	install -D -m644 LICENSE ${pkgdir}/usr/share/licenses/gmqcc/LICENSE
}
